/*
 * This is a very simple C program used to probe the PCI bus, and compare the
 * vendor and model ID of every card found against the pcitable ASCII
 * database. From there it pulls the correct module name, and prints all of
 * the module names that were found for your system.
 *
 * Written by: Greg Kurtzer <greg@caosity.org>
 * License: GPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/utsname.h>
#include <ctype.h>
#include <sys/types.h>
#include <dirent.h>
#include <linux/pci_ids.h>

#include "config.h"

long long vendor (char *addr) {
	FILE *fd;
	long long out;
	char file_2_open[BUFFSIZE];
	sprintf(file_2_open, "/sys/bus/pci/devices/%s/vendor", addr);
        if (( fd = fopen(file_2_open, "r")) == NULL ) {
                printf("could not open %s!\n", file_2_open);
                exit(1);
        }
	fscanf(fd, "%Lx", &out);
	fclose(fd);
	return(out);
}

long long device (char *addr) {
	FILE *fd;
	long long out;
	char file_2_open[BUFFSIZE];
	sprintf(file_2_open, "/sys/bus/pci/devices/%s/device", addr);
        if (( fd = fopen(file_2_open, "r")) == NULL ) {
                printf("could not open %s!\n", file_2_open);
                exit(1);
        }
	fscanf(fd, "%Lx", &out);
	fclose(fd);
	return(out);
}

long long class (char *addr) {
	FILE *fd;
	long long out;
	char file_2_open[BUFFSIZE];
	sprintf(file_2_open, "/sys/bus/pci/devices/%s/class", addr);
        if (( fd = fopen(file_2_open, "r")) == NULL ) {
                printf("could not open %s!\n", file_2_open);
                exit(1);
        }
	fscanf(fd, "%Lx", &out);
	fclose(fd);
	return(out);
}
